SET NOCOUNT ON;
go
USE ImEx;
go

IF EXISTS
 (SELECT *
  FROM   sys.objects
  WHERE  object_id = OBJECT_ID(N'dbo.TestResults')
  AND    type = N'U')
BEGIN;
  DROP TABLE dbo.TestResults;
END;
go

CREATE TABLE dbo.TestResults
    (ProcNaam varchar(20) NOT NULL,
     TestNum  int         NOT NULL,
     IterNum  tinyint     NOT NULL,
     Elapsed  int         NOT NULL,
     BinsUsed int         NOT NULL);
go

DECLARE @Tests TABLE
    (ProcNo tinyint       NOT NULL PRIMARY KEY,
     ProcNaam varchar(20) NOT NULL UNIQUE);
INSERT INTO @Tests (ProcNo, ProcNaam)
VALUES (1, 'SetBasedIter'),
       (2, 'SetBasedIter1'),
       (3, 'SetBasedIter2'),
       (4, 'SetBasedIter3'),
       (5, 'SetBasedIter4'),
       (6, 'SetBasedIter2B'),
       (7, 'SetBasedIter1BMin10'),
       (8, 'SetBasedIter1BMin25');

DECLARE @TestNum  int = 0,
        @IterNum  tinyint,
        @Elapsed  int,
        @BinsUsed int,
        @ProcNo   tinyint,
        @ProcNaam varchar(20);

WHILE 1 = 1
BEGIN;
  SET @TestNum += 1;
  SET @IterNum = 0;
  EXEC dbo.GenTestDataProc @TestNum;
  
  WHILE @IterNum < 10
  BEGIN;
    SET @IterNum += 1
    SET @ProcNo = 0;
    WHILE @ProcNo < 8
    BEGIN;
      SET @ProcNo += 1;
      SELECT @ProcNaam = ProcNaam
      FROM   @Tests
      WHERE  ProcNo = @ProcNo;
      EXEC dbo.PerfTestRet @TheProc = @ProcNaam, @Elapsed = @Elapsed OUTPUT, @BinsUsed = @BinsUsed OUTPUT;
      INSERT INTO dbo.TestResults (ProcNaam, TestNum, IterNum, Elapsed, BinsUsed)
      VALUES (@ProcNaam, @TestNum, @IterNum, @Elapsed, @BinsUsed);
    END;
  END;

  -- Delete slowest and fastest results
  WITH Ranked
  AS (SELECT rn = ROW_NUMBER() OVER (PARTITION BY ProcNaam ORDER BY Elapsed)
      FROM   dbo.TestResults
      WHERE  TestNum = @TestNum)
  DELETE Ranked
  WHERE  rn IN (1, 10);

  SELECT   @TestNum AS [Tests completed],
           ProcNaam AS [Proces],
           MIN(Elapsed) AS [Min elapsed],
           MAX(Elapsed) AS [Max elapsed],
           AVG(Elapsed * 1.0) AS [Avg Elapsed],
           MIN(BinsUsed) AS [Min used],
           MAX(BinsUsed) AS [Max used],
           AVG(BinsUsed * 1.0) AS [Avg used]
  FROM     dbo.TestResults
  GROUP BY ProcNaam
  ORDER BY ProcNaam;
END;
